#!/usr/bin/ruby -Ke

require 'const'
require 'net/http'

cmd = ARGV.shift
arg = ARGV.shift

def toeuc(str)
  Kconv::toeuc(str)
end
def j2e(str)
  NKF::nkf('-Je', str)
end
def e2j(str)
  NKF::nkf('-Ej', str)
end

def http_get(url)
  url =~ /http:\/\/([^\/]+)(\/.*)$/
  serv = $1
  path = $2
  Net::HTTP.version_1_2
  if (PROXY_HOST)
    Net::HTTP::Proxy(PROXY_HOST, PROXY_PORT)
  else
    Net::HTTP
  end.start(serv) do |http|
    resp, data = http.get(path, nil)
    while (resp.code =~ /^5/)
      sleep(3)
      resp, data = http.get(path, nil)
    end
    return toeuc(data)
  end
end

if (!cmd)
  print "usage: #{$0} cmd arg\n"
  exit(1)
end

#require "plugins/#{cmd}"
@plugins = Hash.new
Dir.open('plugins') do |dir|
  dir.each do |d|
    begin
      if (d.to_s !~ /^([^\.]*)\.rb$/)
        next
      end
      open("plugins/#{$1}.rb") do |src|
        self.instance_eval(src.read)
      end
      @plugins[$1] = self.method("#{$1}_desc").call
    rescue
      p $!.to_s
      print "#{$!.backtrace.join("\n")}\n"
    end
  end
end

p eval("#{cmd}('#{arg}')")
